// Creamos una gráfica con los datos al macenados en config
var ctx = document.getElementById('myChart').getContext('2d');
//ctx.canvas.width = 256;
//ctx.canvas.height = 512;
var myChart = new Chart(ctx, config);
//var activePoints = [];
var activePoints = config.data.labels;
var imageNumber = 0;
var playImages;
var reportImg = activePoints[0];
//var myChart;


// mostrar imagen al dar click en los puntos
document.getElementById("myChart").onclick = function (evt) {
    stop();
    console.log("on click")
    
    console.log("evento: ")
    console.log(evt)
    // activePoints = myChart.getElementsAtEvent(evt);
    var activePoint = myChart.getElementAtEvent(evt);
    console.log("activePoint: ")
    console.log(activePoint)
    console.log(activePoint.length)
    if(activePoint.length>0){
      
        var firstPoint = activePoint[0];
        //console.log(firstPoint)
        //console.log(firstPoint._datasetIndex)    //indice de la clase a la que pertenece (vegetación, agua, etc.)
        var label = myChart.data.labels[firstPoint._index];
        console.log("label: ")
        console.log(label)
        //console.log(myChart.legend.legendItems[firstPoint._datasetIndex].text) //nombre de la capa a la que pertenece (vegetación, agua, etc.)
        //if (!firstPoint) return;
        activePoints.forEach(function (value, index) {
            //if(value==firstPoint){
            if (value == label) {
                imageNumber = index;
            }
        });

        var imagePoint = activePoints[imageNumber];
        updateImage(imagePoint);
        //updateImage(firstPoint);
        //alert("{{ IMAGE_PATH }}"+label+"_TCI_60m.jpg");
        //document.getElementById("satImage").src = "{{ IMAGE_PATH }}"+label+"_TCI_60m.jpg";
    }
};




function play() {
    $("#play").hide();
    $("#stop").show();
    // $(".next").hide();
    // $(".prev").hide();
    // $("#showImage").addClass('col-lg-offset-1');
    playImages = setInterval(function () { next(); }, 4000);
}

 //****************************       
function scl_on(imagePoint) {
     console.log("scl on!!")
     label = imagePoint;
     //console.log({{SCL_PATH}})
     document.getElementById("satImage").src = "../../static/reports/tmpImages/repsat_test_dev/{{SCL_PATH}}" + label + "_SCL_60m_clasificationMap.png"
     // $(".next").show();
     // $(".prev").show();    
}

function scl_stop() {
     console.log("scl off!!")
     // $(".next").show();
     // $(".prev").show();    
}        
//********************************

function stop() {
    clearInterval(playImages)
    // $("#showImage").removeClass('col-lg-offset-1');
    $("#play").show();
    $("#stop").hide();
    // $(".next").show();
    // $(".prev").show();    
}

// cambiar el tipo de gráfica
function next() {
    if (imageNumber == (activePoints.length - 1)) {
        imageNumber = 0;
    } else {
        imageNumber++;
    }
    var imagePoint = activePoints[imageNumber];

    if (!imagePoint) return;
    updateImage(imagePoint);
}

function prev() {
    if (imageNumber == 0) {
        imageNumber = activePoints.length - 1;
    } else {
        imageNumber--;
    }

    var imagePoint = activePoints[imageNumber];

    if (!imagePoint) return;
    updateImage(imagePoint);
}

function updateImage(imagePoint) {
    //label = myChart.data.labels[imagePoint._index];
    //datasets = myChart.data.datasets[imagePoint._datasetIndex].label;
    //document.getElementById("titleMap").innerHTML = label + " - " + datasets;
    label = imagePoint;
    reportImg = imagePoint;
    titleLabel = label.slice(0, 4) + "/" + label.slice(4, 6) + "/" + label.slice(6);
    document.getElementById("titleMap").innerHTML = titleLabel;
    document.getElementById("satImage").src = "../../static/reports/tmpImages/repsat_test_dev/" + image_path + label + "_TCI_60m.jpg"
    
    document.getElementById("scl_saturated").src = "../../static/reports/tmpImages/repsat_test_dev/" + scl_path + label + "_SCL_60m_saturated.png"
    document.getElementById("scl_shadows").src = "../../static/reports/tmpImages/repsat_test_dev/" + scl_path + label + "_SCL_60m_shadows.png"
    document.getElementById("scl_cloud_shadows").src = "../../static/reports/tmpImages/repsat_test_dev/" + scl_path + label + "_SCL_60m_cloud_shadows.png"
    document.getElementById("scl_vegetation").src = "../../static/reports/tmpImages/repsat_test_dev/" + scl_path + label + "_SCL_60m_vegetation.png"
    document.getElementById("scl_not-vegetated").src = "../../static/reports/tmpImages/repsat_test_dev/" + scl_path + label + "_SCL_60m_not-vegetated.png"
    document.getElementById("scl_water").src = "../../static/reports/tmpImages/repsat_test_dev/" + scl_path + label + "_SCL_60m_water.png"
    document.getElementById("scl_unclassified").src = "../../static/reports/tmpImages/repsat_test_dev/" + scl_path + label + "_SCL_60m_unclassified.png"
    document.getElementById("scl_cloud_medium_probability").src = "../../static/reports/tmpImages/repsat_test_dev/" + scl_path + label + "_SCL_60m_cloud_medium_probability.png"
    document.getElementById("scl_cloud_high_probability").src = "../../static/reports/tmpImages/repsat_test_dev/" + scl_path + label + "_SCL_60m_cloud_high_probability.png"
    document.getElementById("scl_thin_cirrus").src = "../../static/reports/tmpImages/repsat_test_dev/" + scl_path + label + "_SCL_60m_thin_cirrus.png"
    document.getElementById("scl_snow").src = "../../static/reports/tmpImages/repsat_test_dev/" + scl_path + label + "_SCL_60m_snow.png"
    
    //document.getElementById("scl_vegetation").src = "../../static/reports/tmpImages/repsat_test_dev/" + scl_path + label + "_SCL_60m_vegetation.png"
}

function change(newType) {
    var ctx = document.getElementById("myChart").getContext("2d");

    // Remove the old chart and all its event handles
    if (myChart) {
        myChart.destroy();

    }

    // Chart.js modifies the object you pass in. Pass a copy of the object so we can use the original object later
    var temp = jQuery.extend(true, {}, config);
    temp.type = newType;
    if (newType == 'radar' || newType == 'pie' || newType == 'polarArea' || newType == 'doughnut') {
        temp.options.scales.xAxes = { "display": false };
        temp.options.scales.yAxes = { "display": false };

    }

    myChart = new Chart(ctx, temp);
};